#include<bits/stdc++.h>
#define MAXN 100007
using namespace std;

int n,q,a[MAXN],l,r;
vector<int> w;
bool dali;

void brute(int x,long long o,long long a,int c,int d){
    if(x==-1){
        if(o==a and c==1 and d==1)dali=true;
        return;
    }else{
        brute(x-1,(o|w[x]),a,1,d);
        brute(x-1,o,(a&w[x]),c,1);
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>q;
    for(int i=1;i<=n;i++){
        cin>>a[i];
    }
    for(int i=1;i<=q;i++){
        cin>>l>>r;
        w.clear();
        for(int f=l;f<=r;f++){
            w.push_back(a[f]);
        }
        dali=false;
        brute(int(w.size())-1,0,(1LL<<31)-1,0,0);
        if(dali)cout<<"Yes\n";
        else cout<<"No\n";
    }

    return 0;
}

